//
//  SvmPredictor.h
//  SvmPredictor
//
//  Created by 熊田 聖也 on 12/06/03.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#ifndef SvmPredictor_SvmPredictor_h
#define SvmPredictor_SvmPredictor_h
#include <boost/noncopyable.hpp>
#include <string>
#include <shogun/lib/common.h>

namespace cv 
{
        class Mat;
        
}
namespace shogun
{
        class CLibSVM;
        template<typename T>
        class CSimpleFeatures;
}

class SvmPredictor : private boost::noncopyable
{
public:
        SvmPredictor();
        ~SvmPredictor();
        
        bool load(const std::string& svm_filename);
        
        bool apply(
                const std::string&      data_path, 
                const std::string&      labels_path
        ) const;

        void apply(
                const cv::Mat&          data, 
                const std::string&      labels_path
        ) const;

        float64_t apply(int i) const;
        int get_features_size() const;
        
private:
        shogun::CLibSVM*        svm_;
        
        void apply(
                shogun::CSimpleFeatures<float64_t>*     features, 
                const std::string&                      labels_path
        ) const;


};
#endif
